srand(0)
$city=[]
N_city=16
Temp,N_loop=0.05,10000 #with arrange2 most stable:3.82306843671205
#Temp,N_loop=0.01,10000 #with arrange2 most stable:3.98316304003795

$count=0
def  print_route(route)
  cont=""
  route.each do |i|
    x,y=$city[i]
    cont << sprintf("%10.5f %10.5f\n",x,y)
  end
  file_name="plots/tmp"+$count.to_s+".txt"
  f1=File.open(file_name,"w")
  f1.print cont
  f1.close
  $count+=1
end

def distance(a,b)
  dx=a[0]-b[0]
  dy=a[1]-b[1]
  return Math::sqrt(dx*dx+dy*dy)
end

def Energy(a)
  tmp=0.0
  for i in 0..a.size-2 do
    tmp+=distance($city[a[i]],$city[a[i+1]])
  end
  return tmp
end


def init()
  a=[]
  N_city.times do |i|
    $city << [rand(),rand()]
    a << i
  end
  a << 0
  return a
end

def arange(a)
  i,j=rand(N_city-1)+1,rand(N_city-1)+1
  if i==j then return a end
  da=Array.new(a)
  da[i],da[j]=da[j],da[i]
  return da
end

def arange2(a)
  i,j=rand(N_city-1)+1,rand(N_city-1)+1
  if i==j then return a end
  if i>j then i,j=j,i end
  da=Array.new(a)
  dd=da[i..j].reverse
  da[i..j]=dd
  return da
end

a=init()
p e0=Energy(a)
print_route(a)
N_loop.times do
  if (da=arange2(a))==a then next end
  e1=Energy(da)
  dE = e1-e0
  if Math::exp(-dE/Temp)>rand() then
    a = da
    p e0=e1
    print_route(a)
  end
end 
